#ifndef INSTALLEDFILE_H_
#define INSTALLEDFILE_H_

#include "sourcepackage.h"
#include "filetarget.h"

/**
Represents the installation of a file.
*/
class InstalledFile: public FileTarget
{
private:
	FileTarget &source;
	Msp::FS::Path link;

public:
	InstalledFile(Builder &, const SourcePackage &, FileTarget &, const std::string & =std::string());
private:
	static Msp::FS::Path generate_target_path(const Msp::FS::Path &, const FileTarget &i, const std::string &);

public:
	virtual const char *get_type() const { return "InstalledFile"; }
	FileTarget &get_source() const { return source; }

	/** Sets a symlink for the file.  A relative path will be rooted at the
	directory the file resides in. */
	void set_symlink(const Msp::FS::Path &);

	const Msp::FS::Path &get_symlink() const { return link; }

	virtual Target *get_real_target();
private:
	virtual void check_rebuild();

public:
	virtual void clean();
};

#endif
